
#property copyright "Copyright  2010, DFD_SMA_v01"
#property link      "DFD_v01@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Blue
#property indicator_color3 Red

extern int Length = 10;
extern double Kv = 1.0;
extern int StepSize = 0;
extern int MA_Mode = 0;
extern int Advance = 0;
extern double Percentage = 0.0;
extern bool HighLow = FALSE;
extern int ColorMode = 0;
extern int BarsNumber = 0;
double g_ibuf_120[];
double g_ibuf_124[];
double g_ibuf_128[];
double g_ibuf_132[];
double g_ibuf_136[];
double g_ibuf_140[];
double gd_144 = 0.0;
double gd_152 = 0.0;
double gd_160 = -100000.0;
double gd_168 = 1000000.0;
int gi_176;

double StepSizeCalc(int ai_0, double ad_4, int ai_12, int ai_16) {
   double ld_ret_20;
   double ld_28;
   double ld_40;
   if (ai_12 == 0) {
      ld_28 = 0;
      for (int li_36 = ai_0 - 1; li_36 >= 0; li_36--) {
         if (MA_Mode == 0) ld_40 = 1.0;
         else ld_40 = 1.0 * (ai_0 - li_36) / ai_0 + 1.0;
         ld_28 += ld_40 * (High[ai_16 + li_36] - (Low[ai_16 + li_36]));
      }
      gd_152 = ld_28 / ai_0;
      if (gd_152 > gd_160) gd_160 = gd_152;
      if (gd_152 < gd_168) gd_168 = gd_152;
      ld_ret_20 = MathRound(ad_4 / 2.0 * (gd_160 + gd_168) / Point);
   } else ld_ret_20 = ad_4 * StepSize;
   return (ld_ret_20);
}

double DFDCalc(bool ai_0, double a_pips_4, int ai_12) {
   double ld_ret_20;
   int l_ind_counted_16 = IndicatorCounted();
   if (ai_0) {
      g_ibuf_136[ai_12] = Low[ai_12] + 2.0 * a_pips_4 * Point;
      g_ibuf_132[ai_12] = High[ai_12] - 2.0 * a_pips_4 * Point;
   } else {
      g_ibuf_136[ai_12] = Close[ai_12] + 2.0 * a_pips_4 * Point;
      g_ibuf_132[ai_12] = Close[ai_12] - 2.0 * a_pips_4 * Point;
   }
   if (l_ind_counted_16 == 0) {
      g_ibuf_136[gi_176 + 1] = g_ibuf_136[gi_176];
      g_ibuf_132[gi_176 + 1] = g_ibuf_132[gi_176];
      g_ibuf_140[gi_176 + 1] = 0;
   }
   g_ibuf_140[ai_12] = g_ibuf_140[ai_12 + 1];
   if (Close[ai_12] > g_ibuf_136[ai_12 + 1]) g_ibuf_140[ai_12] = 1;
   if (Close[ai_12] < g_ibuf_132[ai_12 + 1]) g_ibuf_140[ai_12] = -1;
   if (g_ibuf_140[ai_12] > 0.0) {
      if (g_ibuf_132[ai_12] < g_ibuf_132[ai_12 + 1]) g_ibuf_132[ai_12] = g_ibuf_132[ai_12 + 1];
      ld_ret_20 = g_ibuf_132[ai_12] + a_pips_4 * Point;
   } else {
      if (g_ibuf_136[ai_12] > g_ibuf_136[ai_12 + 1]) g_ibuf_136[ai_12] = g_ibuf_136[ai_12 + 1];
      ld_ret_20 = g_ibuf_136[ai_12] - a_pips_4 * Point;
   }
   return (ld_ret_20);
}

int init() {
  
  string ls_0 = "2012.08.31";
   int l_str2time_8 = StrToTime(ls_0);
   if (TimeCurrent() >= l_str2time_8) {
      Alert(" Demo scaduto!Manda un email a  DFD_v01@yahoo.com oppure vai al sito http://dfdv01.blogspot.com/ per la versione completta!");
      return (0);
   }
   string ls_unused_0;
   IndicatorBuffers(6);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 1);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexArrow(1, 159);
   SetIndexArrow(2, 159);
   SetIndexBuffer(0, g_ibuf_120);
   SetIndexBuffer(1, g_ibuf_124);
   SetIndexBuffer(2, g_ibuf_128);
   SetIndexShift(0, Advance);
   SetIndexShift(1, Advance);
   SetIndexShift(2, Advance);
   SetIndexBuffer(3, g_ibuf_132);
   SetIndexBuffer(4, g_ibuf_136);
   SetIndexBuffer(5, g_ibuf_140);
   SetIndexDrawBegin(0, Length);
   SetIndexDrawBegin(1, Length);
   SetIndexDrawBegin(2, Length);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
 string ls_0 = "2012.08.31";
   int l_str2time_8 = StrToTime(ls_0);
   if (TimeCurrent() >= l_str2time_8) {
      Alert(" Demo scaduto!Manda un email a  DFD_v01@yahoo.com oppure vai al sito http://dfdv01.blogspot.com/ per la versione completta!");
      return (0);
   }

   int li_8;
   int li_12;
   int l_ind_counted_4 = IndicatorCounted();
   if (BarsNumber > 0) li_8 = BarsNumber;
   else li_8 = Bars;
   if (l_ind_counted_4 > 0) gi_176 = li_8 - l_ind_counted_4;
   if (l_ind_counted_4 < 0) return (0);
   if (l_ind_counted_4 == 0) gi_176 = li_8 - Length - 1;
   for (int li_0 = gi_176; li_0 >= 0; li_0--) {
      li_12 = StepSizeCalc(Length, Kv, StepSize, li_0);
      gd_144 = DFDCalc(HighLow, li_12, li_0) + Percentage / 100.0 * li_12 * Point;
      if (ColorMode == 0) g_ibuf_120[li_0] = gd_144;
      if (ColorMode == 1) {
         if (g_ibuf_140[li_0] > 0.0) {
            g_ibuf_124[li_0] = gd_144 - li_12 * Point;
            g_ibuf_128[li_0] = EMPTY_VALUE;
         } else {
            if (g_ibuf_140[li_0] < 0.0) {
               g_ibuf_128[li_0] = gd_144 + li_12 * Point;
               g_ibuf_124[li_0] = EMPTY_VALUE;
            }
         }
      } else {
         if (ColorMode == 2) {
            if (g_ibuf_140[li_0] > 0.0) {
               g_ibuf_124[li_0] = gd_144;
               if (g_ibuf_140[li_0 + 1] < 0.0) g_ibuf_124[li_0 + 1] = g_ibuf_128[li_0 + 1];
               g_ibuf_128[li_0] = EMPTY_VALUE;
            }
            if (g_ibuf_140[li_0] < 0.0) {
               g_ibuf_128[li_0] = gd_144;
               if (g_ibuf_140[li_0 + 1] > 0.0) g_ibuf_128[li_0 + 1] = g_ibuf_124[li_0 + 1];
               g_ibuf_124[li_0] = EMPTY_VALUE;
            }
         } else {
            g_ibuf_124[li_0] = EMPTY_VALUE;
            g_ibuf_128[li_0] = EMPTY_VALUE;
         }
      }
   }
   return (0);
}